import sys
#if not('/usr/lib/pymodules/python2.6' in sys.path) :
#    sys.path.append('/usr/lib/pymodules/python2.6')
#if not('/usr/lib/python2.6' in sys.path) :
#    sys.path.append('/usr/lib/python2.6')
#if not('/home/user/.PyCharm10' in sys.path) :
#    sys.path.append('/home/user/.PyCharm10')

from fbugz.fbSOAPClient import FBClient
from youtrack.connection import Connection
from youtrack import Group, User, Subsystem, Version, Issue, Comment, Link
from fbugz import defaultFBugz
import fbugz

def main() :
    try :
        target_url, target_login, target_password, source_url, source_login, source_password, num = sys.argv[1:8]
        project_names = fbugz.PROJECTS_TO_IMPORT
        max_issue_id = int(num)
    except :
        print "Usage : "
        print "fb2youtrack.py target_url target_login target_password source_url source_login source_password max_issue_id project_names"
        exit()
#    target_url = 'http://unit-190.labs.intellij.net:8082'
#    target_login = 'root'
#    target_password = 'root'
#    source_url = 'https://import-script.fogbugz.com/'
#    source_login = 'fogbugz.import@gmail.com'
#    source_password = '94829482'
#    max_issue_id = 15
    fb2youtrack(target_url, target_login, target_password, source_url, source_login, source_password, project_names, max_issue_id)

def _to_yt_user(fb_user) :
    user = User()
    user.login = fb_user.login.replace(' ', '_')
    user.fullName = fb_user.login.replace(' ', '_')
    user.email = fb_user.email
    user.group = fb_user.user_type
    return user

def _to_yt_subsystem(area) :
    subsystem = Subsystem()
    subsystem.name = area.name
    assignee = area.person_owner
    if (assignee is not None) :
        subsystem.defaultAssignee = assignee
    else :
        subsystem.defaultAssignee = '<no user>'
    subsystem.isDefault = False
    return subsystem

def _to_yt_version(milestone) :
    version = Version()
    version.name = milestone.name
    version.isReleased = milestone.inactive
    version.isArchived = False
    version.releaseDate = milestone.release_date
    return version

def _to_yt_comment(fb_comment) :
    comment = Comment()
    comment.author = fb_comment.author
    comment.text = fb_comment.text
    comment.created = fb_comment.date
    return comment

def _to_yt_issue(fb_issue) :
    issue = Issue()
    issue.numberInProject = str(fb_issue.ix_bug)
    issue.summary = fb_issue.title
    issue.created = fb_issue.opened
    issue.reporterName = fb_issue.reporter.replace(' ', "_")
    issue.assigneeName = fb_issue.assignee.replace(' ', "_")
    issue.subsystem = fb_issue.area
    issue.fixedVersion = fb_issue.fix_for
    issue.type = fbugz.CATEGORY[fb_issue.category]
    issue.priority = fbugz.PRIORITY[fb_issue.priority]
    for key in fbugz.STATUS.keys() :
        if (key in fb_issue.status) :
            issue.state = fbugz.STATUS[key]
    if (fb_issue.due is not None) :
        issue["Due date"] = fb_issue.due
    issue["Original title"] = fb_issue.original_title
    issue["Version"] = fb_issue.version
    issue["Computer"] = fb_issue.computer
    issue["Estimate"] = str(fb_issue.estimate)
    issue.comments = []
    is_description = True
    for c in fb_issue.comments :
        if (is_description) :
            issue.description = c.text
            is_description = False
        else :
            issue.comments.append(_to_yt_comment(c))
    return issue


def _do_import_users(target, users_to_import):
    target.importUsers(users_to_import)
    for u in users_to_import:
        target.setUserGroup(u.login, u.group)

def fb2youtrack(target_url, target_login, target_password, source_url, source_login, source_password, project_names, max_issue_id) :
    #encoding = 'utf-8'
    source = FBClient(source_url, source_login, source_password)
    target = Connection(target_url, target_login, target_password)
    accessible_projects = source.list_project_names()
    for p_name in project_names :
        if not(p_name in  accessible_projects.keys()) :
            print 'Unknown project names. Exiting...'
            exit()

#    for p_name in accessible_projects :
#        if (p_name.encode('utf-8') in project_names_str) :
#            project_names_str.remove(p_name.encode('utf-8'))
#            project_names.append(p_name)
#
#    if (len(project_names_str) != 0) :
#        print 'Unknown project names!'

    print 'Creating custom fields'
    fields = {'Original title'  :   'string',
              'Version'         :   'string',
              'Computer'        :   'string',
              'Due date'        :   'date',
              'Estimate'        :   'integer'
    }
    for f in fields.keys() :
        try :
            target.createCustomFieldDetailed(f, fields[f], False, True)
        except Exception, ex :
            print "Can't create custom field with name [ %s ] (maybe because it already exists)" % f


    print 'Importing users'
    for name in ['Normal', 'Deleted', 'Community', 'Virtual'] :
        group = Group()
        group.name = name
        try :
            target.createGroup(group)
            print 'Group with name [ %s ] successfully created' % name
        except :
            print "Can't create group with name [ %s ] (maby because it already exists)" % name


    users_to_import = []
    max = 100
    for user in source.get_users() :
        yt_user = _to_yt_user(user)
        print 'Importing user [ %s ]' % yt_user.login
        users_to_import.append(yt_user)
        if (len(users_to_import) >= max) :
            _do_import_users(target, users_to_import)
            users_to_import = []
    _do_import_users(target, users_to_import)
    print 'Importing users finished'

    # to handle linked issues
    try :
        target.createIssueLinkTypeDetailed('parent-child', 'child of', 'parent of', True)
    except :
        print "Can't create issue link type [ parent-child ] (maybe because it already exists)"
    links_to_import = []

    for project_name in project_names :
        project_id = accessible_projects[project_name]
        print 'Importing project [ %s ]' % project_name
        target.createProjectDetailed(project_id, project_name.encode('utf-8'), 'no desription', target_login)

        print 'Creating custom fields in project [ %s ]' % project_name

        for name in fields.keys() :
            target.createProjectCustomFieldDetailed(project_id, name, 'No ' + name)
            print 'Custom field [ %s ] attached to project [ %s ]' % (name, project_name)
        print 'Creating custom fields in project [ %s ] finished' % project_name

        print 'Importing areas for project [ %s ]' % project_name
        for area in source.get_areas(accessible_projects[project_name]) :
            subsystem = _to_yt_subsystem(area)
            print 'Importing subsystem [ %s ] in project [ %s ]' % (subsystem.name, project_name)
            target.createSubsystem(project_id, subsystem)
        print 'Importing areas for project [ %s ] finished' % project_name

        print 'Importing versions for project [ %s ]' % project_name
        for milestone in source.get_milestones(accessible_projects[project_name]) :
            version = _to_yt_version(milestone)
            print 'Importing version [ %s ] in project [ %s ]' % (version.name, project_name)
            target.createVersion(project_id, version)
        print 'Importing versions for project [ %s ] finished' % project_name

        print 'Importing issues for project [ %s ]' % project_name
        start = 0
        issues_to_import = []
        # create dictionary with child : parent pairs
        while start <= max_issue_id:
            fb_issues = source.get_issues(project_name, start, 30)
            for issue in fb_issues :
                issues_to_import.append(_to_yt_issue(issue))
            target.importIssues(project_id, project_name.encode('utf-8') + " assignees", issues_to_import)
            for issue in fb_issues :
                full_issue_id = '%s-%s' % (project_id, issue.ix_bug)
                for attach in issue.attachments :
                    target.createAttachmentFromAttachment(full_issue_id, attach)
                for tag in issue.tags :
                    target.executeCommand(full_issue_id, 'tag ' + tag)
                if issue.bug_parent is not None:
                    parent_issue_id = '%s-%s' % (source.get_issue_project_id(issue.bug_parent), issue.bug_parent)
                    link = Link()
                    link.typeName = 'parent-child'
                    link.source = full_issue_id
                    link.target = parent_issue_id
                    links_to_import.append(link)
            issues_to_import = []
            start += 30
        print 'Importing issues for project [ %s ] finished' % project_name

    print 'Importing issue links'
    print target.importLinks(links_to_import)
    print 'Importing issue links finished'

if __name__ == '__main__':
    main()
