# migrate project from youtrack to youtrack

from youtrack.connection import Connection, youtrack
import httplib2
import socks
#from sets import Set
import youtrack
import sys

#httplib2.debuglevel=4

def main():


#    source_url = 'http://teamsys.intellij.net'
#    source_login = 'xxx'
#    source_password = 'xxx'
#
#    target_url = 'http://v-rot-mne-nogi.myjetbrains.com/youtrack'
#    #target_url = 'http://localhost:8080'
#    target_login = 'xxx'
#    target_password = 'xxx'
#
#    projectId = 'ADM'

    try:
        source_url, source_login, source_password, target_url, target_login, target_password = sys.argv[1:7]
        project_ids = sys.argv[7:]
    except BaseException, e:
        print "Usage: youtrack2youtrack source_url source_login source_password target_url target_login target_password projectId"
        return

    youtrack2youtrack(source_url, source_login, source_password, target_url, target_login, target_password, project_ids)


def youtrack2youtrack(source_url, source_login, source_password, target_url, target_login, target_password, project_ids):
    if (len(project_ids) == 0) :
        print "You should sign at least one project to import"
        return

    source = Connection(source_url, source_login, source_password)
    target = Connection(target_url, target_login, target_password) #, proxy_info = httplib2.ProxyInfo(socks.PROXY_TYPE_HTTP, 'localhost', 8888)

    print "Import issue link types"
    for ilt in source.getIssueLinkTypes():
        try:
            print target.createIssueLinkType(ilt)
        except youtrack.YouTrackException, e:
            print e.message

#    print "Import custom field prototypes"
#    cf_names = set([])
#    for projectId in project_ids :
#        # collecting cf names to import
#        pcfs = source.getProjectCustomFields(projectId)
#        for pcf in pcfs :
#            cf_names.add(pcf.name)
#
#    for name in cf_names :
#        print "Create custom field [ %s ]" % name
#        target.createCustomField(source.getCustomField(name))

    links = []
    created_groups = set([])

    for projectId in project_ids :

        # copy project, subsystems, versions
        project = source.getProject(projectId)

        print "Import project [" + project.name + "]"
        lead = source.getUser(project.lead)

        print "Create project lead [" + lead.login +  "]"
        print target.createUser(lead)

        try:
            target.getProject(projectId)
        except youtrack.YouTrackException:
            target.createProject(project)

        print "Create users for subsystems"
        subsystems = source.getSubsystems(projectId)
        users = set([])
        for s in subsystems:
            if s.defaultAssignee != '<no user>' and s.defaultAssignee != '':
                users.add(source.getUser(s.defaultAssignee))
        print target.importUsers(users)

        print "Create subsystems"
        for s in subsystems:
            try:
                print target.createSubsystem(projectId, s)
            except youtrack.YouTrackException, e:
                print e.message

        print "Create versions"
        versions = source.getVersions(projectId)
        for v in versions :
            print "Processing version [ %s ]" % v.name
            try:
                print target.createVersion(projectId, v)
            except youtrack.YouTrackException, e:
                print e.message

        cf_ignored_values = dict([])
        print "Create custom fields"
        for pcf in source.getProjectCustomFields(projectId):

            print "Create custom field [" + pcf.name + "]"
            # create global custom fields
            try:
                print target.createCustomField(source.getCustomField(pcf.name))
            except youtrack.YouTrackException, e:
                print e.message
            cf_ignored_values[pcf.name] = pcf.emptyText
            #  create bundle if needed
            try:
                if pcf.type.startswith('enum'):
                    print target.createEnumBundle(source.getEnumBundle(pcf.bundle))
            except youtrack.YouTrackException, e:
                print e.message

            try:
                print target.createProjectCustomField(projectId, pcf)
            except youtrack.YouTrackException, e:
                print e.message

        # TODO: copy assignees

        # copy issues
        start = 0
        max = 100

        print "Import issues"
        createdUsers = set([])

        while True:
            print "Get issues from " + str(start) + " to " + str(start + max)
            issues = source.getIssues(projectId, '', start, max)


            if len(issues) <= 0:
                break

            users = set([])

            for issue in issues:
                print "Collect users for issue [ " + issue.id + "]"

                if issue.reporterName not in createdUsers:
                    users.add(issue.getReporter())
                if issue.hasAssignee() and issue.assigneeName not in createdUsers:
                    users.add(issue.getAssignee())
                #TODO: http://youtrack.jetbrains.net/issue/JT-6100
                #users.add(issue.getUpdater())

                for comment in issue.getComments():
                    if comment.author not in createdUsers:
                        users.add(comment.getAuthor())

                print "Collect links for issue [ " + issue.id + "]"
                links.extend(issue.getLinks(True))


            users = users.difference(createdUsers)


            print "Create users [" + str(len(users)) + "]"
            for user in users :
                if (not("email" in user.__dict__)) :
                    user.email = "<no email>"
            print target.importUsers(users)


            for yt_user in users :
                user_groups = source.getUserGroups(yt_user.login)
                for group in user_groups :
                    if (not(group in created_groups)) :
                        try :
                            target.createGroup(group)
                        except Exception, ex :
                            print ex
                    created_groups.add(group)
                    try :
                        target.setUserGroup(yt_user.login, group.name)
                    except :
                        pass

            createdUsers = createdUsers.union(users)

            for issue in issues :
                for key in cf_ignored_values :
                    if (key in issue) :
                        if (issue[key] == cf_ignored_values[key]) :
                            issue[key] = ""

            print "Create issues [" + str(len(issues)) + "]"
            print target.importIssues(projectId, project.name + ' Assignees', issues)

            print "Transfer attachments"
            for issue in issues:
                for a in issue.getAttachments():
                    print "Transfer attachment of " + issue.id + ": " + a.name
                    # TODO: add authorLogin to workaround http://youtrack.jetbrains.net/issue/JT-6082
                    a.authorLogin = target_login
                    target.createAttachmentFromAttachment(issue.id, a)

            start += max

    print "Import issue links"
    maxLinks = 100
    links_to_import = []
    for l in links :
        links_to_import.append(l)
        if (len(links_to_import) == maxLinks) :
            print target.importLinks(links_to_import)
            links_to_import = []
    if (len(links_to_import) != 0) :
        print target.importLinks(links_to_import)

if __name__ == "__main__":
    main()
